#include "main.h"
#include "raster.h"
#include "geometry.h"
#include "bitmap.h"
#include <stdio.h>
#include <memory.h>
#include <malloc.h>
//---------------------------------------------------------------------------

void Draw_Scene_ZBuffer()
{
double *ZB=0;
ZB=new double[RWidth*RHeight];
for (long kk=0;kk<RWidth;kk++)
 for (long mm=0;mm<RHeight;mm++)
 {ZB[kk+mm*RWidth]=0;}
	//         
	Init_Raster_Frame();
	//      ( )
	Plane_struct plane(0,0,-1,-MINIMUM_Z);
	//     
	Line_struct left(-1,0,0),right(1,0,RWidth);
	Line_struct top(0,-1,0),bottom(0,1,RHeight);
	//   
	for(long i=0;i<Number_Faces;i++)
	{
		const Face_struct &face=Faces[i];
		//    
		Circle_List_Template<Vertex3D_struct> Poly3D;
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[0]]));
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[1]]));
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[2]]));
		//    
		if (TruncPolygon3D(Poly3D,plane))
		{
			//    
			Circle_List_Template<Vertex2D_struct> Poly2D;
			ProjectPolygon(Poly3D,Poly2D);

			//    
			if (	TruncPolygon2D(Poly2D,left)	&&	TruncPolygon2D(Poly2D,right)
				&&	TruncPolygon2D(Poly2D,top)	&&	TruncPolygon2D(Poly2D,bottom)	)
			{
				//  
				//Raster_PolygonX(Poly2D,face.color_id);
                       {
	Edge_List_struct *Edge1=0,*Edge2=0;
	//        
	long ys,ye;
	Prepare_Raster_Polygon(Poly2D,0,ys,ye);
	for(long y=ys;y<ye;y++)
	{
		//,   
		if (Edge1 && (y>=Edge1->end))	safe_delete(Edge1);
		if (Edge2 && (y>=Edge2->end))	safe_delete(Edge2);
		//    
		if (Edge1)	{	Edge1->x+=Edge1->dx;	Edge1->w+=Edge1->dw;	}
		if (Edge2)	{	Edge2->x+=Edge2->dx;	Edge2->w+=Edge2->dw;	}
		//  
		while(LineEdges[y])
		{
			if (!Edge1)			Edge1=LineEdges[y];
			else if (!Edge2)	Edge2=LineEdges[y];
			else	assert(0,"    ");
			LineEdges[y]=LineEdges[y]->next;
		}
		assert(Edge1 && Edge2,"    ");
		if (!Edge1 || !Edge2) continue;

		// Edge1      Edge2
		if (Edge1->x>Edge2->x)	swap(Edge1,Edge2);

		//    
		long xs=(long)floor(Edge1->x+0.5);
		long xe=(long)floor(Edge2->x+0.5);
		//      
		if (xs<0)	xs=0;
		if (xe>RWidth)	xe=RWidth;
		//   
		if (xs>=xe)	continue;

		// 
		float dw=(Edge2->w-Edge1->w)/(Edge2->x-Edge1->x);
		float w=Edge1->w+dw*(xs+0.5f-Edge1->x);
		for(long x=xs;x<xe;x++)
		{
                if (w>ZB[x+y*RWidth])
                        {
                        ZB[x+y*RWidth]=w;
			Put_Pixel(x,y,face.color_id);
                        }
 		// w-   
                w+=dw;
		}
	}
	safe_delete(Edge1);
	safe_delete(Edge2);
}
			}
			//     
			Poly2D.clear();
		}
		//     
		Poly3D.clear();
	}
delete(ZB);
};

//---------------------------------------------------------------------------
// -  
#define NUMBER_SCENES		5
// -   
#define NUMBER_RESOLUTIONS	5

//---------------------------------------------------------------------------
//  
void User_Main()
{
	//   
//	User_Test();	return;

	//      
	double time[NUMBER_SCENES][NUMBER_RESOLUTIONS];
	// -    
	long number_pixels[NUMBER_RESOLUTIONS];
	// -    
	long number_polygones[NUMBER_SCENES];

	for(int i=0;i<NUMBER_SCENES;i++)
	{
		//  scene_X, X -    
		if (!LoadScene("Data\\scene_2",i+1))	return;
		number_polygones[i]=Number_Faces;

		for(int j=0;j<NUMBER_RESOLUTIONS;j++)
		{
			//   
		Set_Resolution_Factor(NUMBER_RESOLUTIONS+1-j);
//	Set_Resolution_Factor(0);
			number_pixels[j]=RWidth*RHeight;
  			double takts=Get_Takts();
  			//  
			switch(3)
			{
				case 3:	Draw_Scene_ZBuffer();		break;
			}
			//    
			time[i][j]=Get_Takts()-takts;
			//    
			Update_View(true);
		}
		//       
		if (i==(NUMBER_SCENES-1))	SaveBMP("result.bmp",ImageArray,Colors,RWidth,RHeight);
		//   
		Clear_Scene();
	}
	//   
	FILE *file = fopen("results.txt","wt");
	assert(file,"   ");
	if (file)
	{
		fprintf(file,"Pixels\\Polygones ");
		for(int i=0;i<NUMBER_SCENES;i++)
			fprintf(file,"    %5d",number_polygones[i]);
		fprintf(file,"\n");
		for(int j=0;j<NUMBER_RESOLUTIONS;j++)
		{
			fprintf(file," %5d           ",number_pixels[j]);
			for(int i=0;i<NUMBER_SCENES;i++)
			{
				fprintf(file," %8d",long(time[i][j]/1000));
			}
			fprintf(file,"\n");
		}
	}
	fclose(file);
}
